 ;CHAOS SAVE WITH PARITY SEND

	ORG	#FE00
	DI
	LD	A,#46
	LD	(BITX+1),A
;LEADER
	LD	HL,#A00
	LD	C,2
LEADL	LD	B,#A3
	DJNZ	$
	LD	A,C
	OUT	(#FE),A
	XOR	#F
	LD	C,A
	DEC	HL
	LD	A,H
	OR	L
	JR	NZ,LEADL
;SYNC
	LD	B,#2F
	DJNZ	$
	OUT	(#FE),A
	LD	A,#D
	LD	B,#A0
	DJNZ	$
	OUT	(#FE),A
	LD	D,0
	LD	L,D
	LD	E,1
SAVEB	LD	B,#25
	LD	A,D
	AND	#1F
	OR	#40
	LD	H,A
BITX	BIT	0,(HL)
	CALL	SEND
	JR	Z,CR
	SCF
CR	RL	E
	JR	NC,SHIFT
;Parity send
	LD	A,E
	AND	A
	JP	PO,PODD
	INC	H
	JR	CS
PODD	CP	A
CS	LD	B,#23
	CALL	SEND
	LD	E,1
SHIFT	LD	A,D
	AND	#B4
	JP	PO,CRES
	SCF
CRES	RL	L
	RL	D
	LD	A,D
	OR	L
	JR	Z,END
	LD	A,D
	AND	#E0
	RRA
	RRA
	OR	#46
	LD	(BITX+1),A
	LD	B,#1A
	JR	SAVEB+2
END	EI
	RET
SEND	LD	A,#05
	DJNZ	$
	JR	Z,IS0
	LD	B,#40
	DJNZ	$
IS0	OUT	(#FE),A
	LD	A,#9
	LD	B,#25
	DJNZ	$
	JR	Z,IT0
	LD	B,#40
	DJNZ	$
IT0	OUT	(#FE),A
	RET


    ;CHAOS LOAD WITH PARITY CHECK

	ORG	#FF00
	CALL	CHLOAD
	CALL	#53F
	RET	C
	RST	8
	DEFB	#1A
CHLOAD	DI
	LD	A,#C6
	LD	(SETX+1),A
	LD	A,#58
	LD	HL,#4000
CLSL	LD	(HL),0
	INC	HL
	CP	H
	JR	NZ,CLSL
	LD	A,#B
	OUT	(#FE),A
	IN	A,(#FE)
	AND	#40
	LD	C,A
	CP	A
BREAK	RET	NZ
	CALL	E1
	JR	NC,BREAK
	LD	HL,#220
WAIT	DJNZ	$
	DEC	HL
	LD	A,H
	OR	L
	JR	NZ,WAIT
	CALL	E2
	JR	NC,BREAK
LEADER	LD	B,#82
	CALL	E2
	JR	NC,BREAK
	LD	A,B
	CP	#41
	JR	NC,BREAK+1
	INC	H
	JR	NZ,LEADER
SYNC	LD	B,#4D
	CALL	E1
	JR	NC,BREAK
	LD	A,#32
	CP	B
	JR	NC,SYNC
	LD	B,#60
	CALL	E1
	RET	NC
	LD	D,0
	LD	L,D
	LD	E,1
	LD	B,#55
LOADL	LD	A,D
	AND	#1F
	OR	#40
	LD	H,A
	CALL	E2
	RET	NC
	LD	A,B
	CP	#30
	PUSH	AF
	JR	NC,NSET
	LD	A,H
	CP	#58
	JR	NC,NSET
SETX	SET	0,(HL)
NSET	POP	AF
	RL	E
	JR	NC,SHIFT
;Parity check
	LD	B,#51
	CALL	E2
	RET	NC
	LD	A,B
	CP	#30
	LD	A,E
	JR	NC,ZERO
	AND	A
	RET	PO
	JR	OK
ZERO	AND	A
	RET	PE
OK	LD	E,1
SHIFT	LD	A,D
	AND	#B4
	JP	PO,CRES
	SCF
CRES	RL	L
	RL	D
	LD	A,D
	OR	L
	JR	Z,END
	LD	A,D
	AND	#E0
	RRA
	RRA
	OR	#C6
	LD	(SETX+1),A
	LD	B,#4A
	JR	LOADL
END	SCF
	RET
E2	CALL	E1
	RET	NC
E1	AND	A
SAMPLE	DEC	B
	RET	Z
	IN	A,(#FE)
	XOR	C
	AND	#40
	JR	Z,SAMPLE
	LD	A,C
	CPL
	LD	C,A
	LD	A,H
	AND	7
	OR	8
	OUT	(#FE),A
	SCF
	RET
